#!/bin/bash

##########################################################################################
#内核参数加固的通用函数
##########################################################################################
function kernel_p_common(){
	declare -i flag=1
	if [ `cat -n /etc/sysctl.conf|grep "$1"|awk '{print $2,$1}'|grep -v "^#"|grep "$1" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
		line=`cat -n /etc/sysctl.conf|grep "$1"|awk '{print $2,$1}'|grep -v "^#"|grep "$1"|tail -n 1|awk  '{print $2}'`
		value=`cat -n /etc/sysctl.conf|grep "$1"|awk '{print $2,$1}'|grep -v "^#"|grep "$1"|tail -n 1|awk  '{print $1}'|awk -F '=' '{print $2}'`
		setline=$(($line - 1))
		if [[ $value -ne $2 ]];then
		
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/sysctl.conf
				if [ `sed -i "1 a $1=$2" /etc/sysctl.conf 2>/dev/null;echo $?` -eq 0 ];then
					flag=0
					echo "MODIFY_CONFIG::/etc/sysctl.conf::$1::$1=$value" >>/var/log/security_reinforce.txt
				fi

			else
				sed -i "$line d" /etc/sysctl.conf
				if [ `sed -i "$setline a $1=$2" /etc/sysctl.conf 2>/dev/null;echo $?` -eq 0 ];then
					flag=0
					echo "MODIFY_CONFIG::/etc/sysctl.conf::$1::$1=$value" >>/var/log/security_reinforce.txt
				fi
			fi
		else
			flag=2

		fi
	else
		if [ `echo "$1=$2" >> /etc/sysctl.conf 2>/dev/null;echo $?` -eq 0 ];then
			flag=0
			echo "ADD_CONFIG::/etc/sysctl.conf::$1::$1=$2" >>/var/log/security_reinforce.txt
		fi
	fi
	return $flag
}

function Passwd_character_class(){
	declare -i flag=1
	declare -i flag1=1
	echo "--系统密码包含字符种类设置"
	echo "--系统密码包含字符种类设置" >>/var/log/security_reinforce.txt
	standard=$1

	if [ ` test -e /etc/security/pwquality.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/security/pwquality.conf |grep -w "minclass" |awk '{print $2, $3, $1}'|egrep "minclass\s+="|grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |grep -w "minclass"|awk '{print $2,$3, $1}'|egrep "minclass\s+=" |grep -v "^#" |tail -n 1|awk '{print $3}'`
			value=`cat -n /etc/security/pwquality.conf |grep -w "minclass"|awk '{print $2,$3,$4, $1}'|egrep "minclass\s+=" |grep -v "^#" |tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
			setline=$(($line - 1))
				
			if [[ $value -lt $standard ]];then
					flag1=0
			
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/security/pwquality.conf
					if [ `sed -i "1 a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::minclass = $value" >>/var/log/security_reinforce.txt
					fi

				else
					sed -i "$line d" /etc/security/pwquality.conf
					if [ `sed -i "$setline a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::minclass = $value" >>/var/log/security_reinforce.txt
					fi
				fi
			fi
		elif [ `cat  /etc/security/pwquality.conf|awk '{print $1, $2, $3}'|egrep "minclass\s+="|grep "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |awk '{print $2, $3, $4, $1}'|egrep "minclass\s+=" |grep "^#" |tail -n 1|awk '{print $4}'`
			value1=`cat /etc/security/pwquality.conf |grep -w "minclass"|tail -n 1`
			setline=$(($line - 1))
			flag1=0
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/security/pwquality.conf
				if [ `sed -i "1 a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::$value1" >>/var/log/security_reinforce.txt
				fi

			else
				sed -i "$line d" /etc/security/pwquality.conf
				if [ `sed -i "$setline a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::$value1" >>/var/log/security_reinforce.txt
				fi
			fi
			flag1=0
		else
			flag1=0
			if [ `echo "minclass = $standard" >> /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				echo "ADD_CONFIG::/etc/security/pwquality.conf::minclass::minclass = $standard" >>/var/log/security_reinforce.txt
			fi
				
		fi
	fi

	if [ $flag1 -eq 1 ];then
		echo -e "--,密码最小字符类别设置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,密码最小字符类别设置,无需加固"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/security_reinforce.txt
	elif [ $flag -eq 0 ];then
		echo -e "--,密码最小字符类别设置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,密码最小字符类别设置,失败"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/security_reinforce.txt
	elif [ $flag -eq 1 ];then
		echo -e "--,密码最小字符类别设置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,密码最小字符类别设置,成功"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/security_reinforce.txt
	fi
}


function Passwd_minlen_setting(){
	declare -i flag1=1
	declare -i flag=1
	
	echo "--系统密码最少长度设置"
	echo "--系统密码最少长度设置" >> /var/log/security_reinforce.txt
	if [ ` test -e /etc/security/pwquality.conf;echo $?` -eq 0 ];then

		minlen=$1
		if [ -z "$minlen" ];then
			echo -e "--,系统密码长度配置,\033[31m [没有输入长度]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			flag1=2
			flag=2
		else
			if [ `cat -n /etc/security/pwquality.conf |grep -w "minlen" |awk '{print $2, $3, $1}'|egrep "minlen\s+="|grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
				line=`cat -n /etc/security/pwquality.conf |grep -w "minlen"|awk '{print $2,$3, $1}'|egrep "minlen\s+=" |grep -v "^#" |tail -n 1|awk '{print $3}'`
				value=`cat -n /etc/security/pwquality.conf |grep -w "minlen"|awk '{print $2,$3,$4, $1}'|egrep "minlen\s+=" |grep -v "^#" |tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
				setline=$(($line - 1))
					
				if [[ $value -lt $minlen ]];then
						flag1=0
				
					if [ $setline -eq 0 ];then
						sed -i "1 d" /etc/security/pwquality.conf
						if [ `sed -i "1 a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::minlen = $value" >>/var/log/security_reinforce.txt
						fi

					else
						sed -i "$line d" /etc/security/pwquality.conf
						if [ `sed -i "$setline a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::minlen = $value" >>/var/log/security_reinforce.txt
						fi
					fi
				fi
			elif [ `cat  /etc/security/pwquality.conf|awk '{print $1, $2, $3}'|egrep "minlen\s+="|grep "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
				line=`cat -n /etc/security/pwquality.conf |awk '{print $2, $3, $4, $1}'|egrep "minlen\s+=" |grep  "^#" |tail -n 1|awk '{print $4}'`
				value=`cat /etc/security/pwquality.conf |egrep "minlen\s+=" |tail -n 1`
				setline=$(($line - 1))
				flag1=0
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/security/pwquality.conf
					if [ `sed -i "1 a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::$value" >>/var/log/security_reinforce.txt
					fi

				else
					sed -i "$line d" /etc/security/pwquality.conf
					if [ `sed -i "$setline a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::$value" >>/var/log/security_reinforce.txt
					fi
				fi
				flag1=0
			else
				flag1=0
				if [ `echo "minlen = $minlen" >> /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo "ADD_CONFIG::/etc/security/pwquality.conf::minlen::minlen = $minlen" >>/var/log/security_reinforce.txt
				fi
					
			fi
		fi
	fi

	if [ $flag1 -eq 1 ];then
		echo -e "--,系统密码最小长度配置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,系统密码最小长度配置,无需加固"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/security_reinforce.txt
	elif [ $flag -eq 0 ];then
		echo -e "--,系统密码最小长度配置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,系统密码最小长度配置,失败"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/security_reinforce.txt
	elif [ $flag -eq 1 ];then
		echo -e "--,系统密码最小长度配置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,系统密码最小长度配置,成功"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/security_reinforce.txt
	fi
}



function Password_usercheck_enable(){

	declare -i flag=1
	declare -i flag1=1
	str=""
	echo "--系统密码包含用户检查配置"

	if [ ` test -e /etc/security/pwquality.conf;echo $?` -eq 0 ];then

		if [ `cat -n /etc/security/pwquality.conf |grep -w "usercheck" |awk '{print $2, $3, $1}'|egrep "usercheck\s+="|grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |grep -w "usercheck"|awk '{print $2,$3, $1}'|egrep "usercheck\s+=" |grep -v "^#" |tail -n 1|awk '{print $3}'`
			value=`cat -n /etc/security/pwquality.conf |grep -w "usercheck"|awk '{print $2,$3,$4, $1}'|egrep "usercheck\s+=" |grep -v "^#" |tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
			setline=$(($line - 1))
				
			if [[ $value -eq 0 ]];then
					flag1=0
			
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/security/pwquality.conf
					if [ `sed -i "1 a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::usercheck::usercheck = $value" >>/var/log/security_reinforce.txt
					fi
				else
					sed -i "$line d" /etc/security/pwquality.conf
					if [ `sed -i "$setline a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::usercheck::usercheck = $value" >>/var/log/security_reinforce.txt
					fi
				fi
			fi
		elif [ `cat  /etc/security/pwquality.conf|awk '{print $1, $2, $3}'|egrep "usercheck\s+="|grep "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |awk '{print $2, $3, $4, $1}'|egrep "usercheck\s+=" |grep "^#" |tail -n 1|awk '{print $4}'`
			setline=$(($line - 1))
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/security/pwquality.conf
				if [ `sed -i "1 a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo -e "COMMAND::0031::::sed -i '/usercheck/s/^#//' /etc/security/pwquality.conf" >>/var/log/security_reinforce.txt
				fi

			else
				sed -i "$line d" /etc/security/pwquality.conf
				if [ `sed -i "$setline a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo -e "COMMAND::0031::::sed -i '/usercheck/s/^#//' /etc/security/pwquality.conf" >>/var/log/security_reinforce.txt
				fi
			fi
			flag1=0
		else
			flag1=0
			if [ `echo "usercheck = 1" >> /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				echo "ADD_CONFIG::/etc/security/pwquality.conf::usercheck::usercheck = 1" >>/var/log/security_reinforce.txt
			fi
				
		fi
	fi
	if [ $flag1 -eq 1 ];then
		echo -e "--,密码包含用户检查设置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 0 ];then
		echo -e "--,密码包含用户检查设置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 1 ];then
		echo -e "--,密码包含用户检查设置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi
}


##########################################################################################
#用户会话超时加固
##########################################################################################
function Session_timeout(){

	declare -i flag=1
	declare -i flag1=1
	echo "--用户会话超时加固"
	echo "--用户会话超时加固" >>/var/log/security_reinforce.txt
	timeout=$1
	if [ -z "$timeout" ];then
		echo -e "--,系统密码最小长度配置,\033[31m [没有输入最小长度]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		flag1=2
		flag=2
	fi

	if [ `cat /tmp/reinforce_status 2>/dev/null|grep "TMOUT=" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
		flag1=3
	else
		if [ `cat -n /etc/bash.bashrc|grep "TMOUT="|awk '{print $2,$0}'|grep -v "^#"|grep "TMOUT=" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			line=`cat -n /etc/bash.bashrc|grep "TMOUT="|awk '{print $2,$0}'|grep -v "^#"|grep "TMOUT="|tail -n 1|awk  '{print $2}'`
			value=`cat -n /etc/bash.bashrc|grep "TMOUT="|awk '{print $2 $3,$1}'|grep -v "^#"|grep "TMOUT="|tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
			setline=$(($line - 1))
			if [ $value -gt $timeout -o $value -eq 0 ];then
			
					if [[ $setline -eq 0 ]];then
						sed -i "1 d" /etc/bash.bashrc
						if [ `sed -i "1 a export TMOUT=$timeout" /etc/bash.bashrc 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/bash.bashrc::TMOUT::TMOUT=$value" >>/var/log/security_reinforce.txt
							echo "TMOUT=1" >>/tmp/reinforce_status
						fi
					else
						sed -i "$line d" /etc/bash.bashrc
						if [ `sed -i "$setline a export  TMOUT=$timeout" /etc/bash.bashrc 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/bash.bashrc::TMOUT::TMOUT=$value" >>/var/log/security_reinforce.txt
							echo "TMOUT=1" >>/tmp/reinforce_status
						fi
					fi
					kysec_set -n exectl -v verified /etc/bash.bashrc
			else
				flag1=0
			fi
		else
			if [ `echo "export TMOUT=$timeout" >> /etc/bash.bashrc 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				kysec_set -n exectl -v verified /etc/bash.bashrc
				echo "ADD_CONFIG::/etc/bash.bashrc::TMOUT::TMOUT=$timeout" >>/var/log/security_reinforce.txt
				echo "TMOUT=1" >>/tmp/reinforce_status
			fi
		fi
	fi

	if [ $flag1 -eq 0 ];then
		echo -e "--,设置会话超时时间,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,无需加固"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/security_reinforce.txt
	elif [ $flag1 -eq 3 ];then
		echo -e "--,设置会话超时时间,\033[32m [无需加固，但需重启系统生效]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,无需加固，但需重启系统生效"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/security_reinforce.txt
	elif [ $flag -eq 0 ];then
		echo -e "--,设置会话超时时间,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,失败"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/security_reinforce.txt
	elif [ $flag -eq 1 ];then
		echo -e "--,设置会话超时时间,\033[32m [成功，需重启系统生效]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,成功"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/security_reinforce.txt
	fi
}

##########################################################################################
#密码历史加固
##########################################################################################
function Password_history(){

	pam-auth-update --package --enable pwhistory
}


##########################################################################################
#口令失败尝试锁定加固
##########################################################################################
function Password_faillock_setting(){

        declare -i flag=1
        declare -i flag1=1
        echo "--口令失败尝试锁定加固"

        string1=`cat /etc/pam.d/common-auth|grep "unlock_time="|grep "deny="|awk '{print $1}'|grep -v "^#"`

        if [ -z "$string1" ];then
                flag1=0
                if [ `sed -i "/pam_unix/s/$/ deny=5 unlock_time=180 root_unlock_time=180/g" /etc/pam.d/common-auth 2>/dev/null;echo $?` -ne 0 ];then
                        flag=0
                fi
        else
                deny=`cat /etc/pam.d/common-auth|grep "unlock_time="|grep "deny="|awk '{print $1 ,$0}'|grep -v "^#"|head -n 1|awk -F 'deny=' '{print $2}'|awk '{print $1}'`
                lock_time=`cat /etc/pam.d/common-auth|grep "unlock_time="|grep "deny="|awk '{print $1 ,$0}'|grep -v "^#"|head -n 1|awk -F 'unlock_time=' '{print $2}'|awk '{print $1}'`
                
                if [ $deny -ne 5 ];then
                        if [ `sed -ri 's/(deny=)[^ ]*/\15/' /etc/pam.d/common-auth 2>/dev/null;echo $?` -ne 0 ];then
                                flag=0
                        fi
                        flag1=0
                fi

                if [ $lock_time -ne 180 ];then
                        if [ `sed -ri 's/(unlock_time=)[^ ]*/\1180/' /etc/pam.d/common-auth 2>/dev/null;echo $?` -ne 0 ];then
                                flag=0
                        fi
                        if [ `sed -ri 's/(root_unlock_time=)[^ ]*/\1180/' /etc/pam.d/common-auth 2>/dev/null;echo $?` -ne 0 ];then
                                flag=0
                        fi
                        flag1=0
                fi
        fi


	if [ $flag1 -eq 1 ];then
		echo -e "--,密码锁定设置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 0 ];then
		echo -e "--,密码锁定设置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	else
		echo -e "--,密码锁定设置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}

##########################################################################################
#记录cron行为日志
##########################################################################################
function Cron_log_configuration(){
	
	echo "--记录cron行为日志"
	if [ `test -e /etc/rsyslog.d/50-default.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/rsyslog.d/50-default.conf|grep "cron.\*"|awk '{print $2,$1}'|grep -v "^#"|grep "cron.\*" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			echo -e "--,cron日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		else
			if [ `echo "cron.*       			/var/log/cron" >> /etc/rsyslog.d/50-default.conf 2>/dev/null;echo $?` -eq 0 ];then
				echo -e "--,cron日志记录加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo "ADD_CONFIG::/etc/rsyslog.d/50-default.conf::cron.*::cron.*       			/var/log/cron" >>/var/log/security_reinforce.txt
			else
				echo -e "--,cron日志记录加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi

		if [ ! -f /var/log/cron ];then
			touch /var/log/cron
			chmod 666 /var/log/cron
		fi
	else
		echo -e "--,cron日志记录加固,\033[31m [请安装日志工具]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}

##########################################################################################
#记录daemon行为日志
##########################################################################################
function Daemon_log_configuration(){
	
	echo "--记录daemon行为日志"
	if [ `test -e /etc/rsyslog.d/50-default.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/rsyslog.d/50-default.conf|grep "daemon.\*"|awk '{print $2,$1}'|grep -v "^#"|grep "daemon.\*" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			echo -e "--,daemon日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		else
			if [ `echo "daemon.*       			-/var/log/daemon.log" >> /etc/rsyslog.d/50-default.conf 2>/dev/null;echo $?` -eq 0 ];then
				echo -e "--,daemon日志记录加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo "ADD_CONFIG::/etc/rsyslog.d/50-default.conf::daemon.*::daemon.*       			-/var/log/daemon.log" >>/var/log/security_reinforce.txt
			else
				echo -e "--,daemon日志记录加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi

		if [ ! -f /var/log/daemon.log ];then
			touch /var/log/daemon.log
			chmod 666 /var/log/daemon.log
		fi
	else
		echo -e "--,daemon日志记录加固,\033[31m [请安装日志工具]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}


##########################################################################################
#SSH登录前banner设置
##########################################################################################
function Ssh_banner_before_login(){

	echo "--SSH登录前banner设置"
	declare -i flag=1
	declare -i flag1=1

	if [ `test -e /etc/ssh/sshd_config;echo $?` -eq 0 ];then
		if [ `cat -n /etc/ssh/sshd_config|grep "Banner"|awk '{print $2,$1}'|grep -v "^#"|grep "Banner" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
			BANNER_LINE=`cat /etc/ssh/sshd_config|grep "Banner"|grep -v "^#"`
			if [ -n "$BANNER_LINE" ]; then
				if [ `sed -i '/^Banner/ s/^/#/' /etc/ssh/sshd_config 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/ssh/sshd_config::Banner::Banner /etc/issue.net" >>/var/log/security_reinforce.txt
				fi
			fi
			flag1=0
		fi
	fi

	if [ $flag1 -eq 1 ];then
                echo -e "--,ssh登录前banner信息加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 0 ];then
                echo -e "--,ssh登录前banner信息加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 1 ];then
                echo -e "--,ssh登录前banner信息加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi
}


##########################################################################################
#SSH登录后banner设置
##########################################################################################
function Ssh_banner_after_login(){

	echo "--SSH登录后banner设置"
	declare -i flag=1
	declare -i flag1=1

	if [ `test -e /etc/pam.d/sshd;echo $?` -eq 0 ];then
		if [ `cat /etc/pam.d/sshd|egrep "session\s+optional\s+pam_motd.so"|awk '{print $1}' |grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			if [ `sed -i '/session[[:space:]]*optional[[:space:]]*pam_motd\.so/ s/^/#/' /etc/pam.d/sshd 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			fi
			flag1=0
		fi
	fi
	
	if [ $flag1 -eq 1 ];then
                echo -e "--,ssh登录后banner信息加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 0 ];then
                echo -e "--,ssh登录后banner信息加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 1 ];then
                echo -e "--,ssh登录后banner信息加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi
}

##########################################################################################
#不接受icmp重定向
##########################################################################################
function Icmp_accept_redirects_disable(){
	echo "--不接受icmp重定向"
	kernel_p1="net.ipv4.conf.all.accept_redirects"
	kernel_p2="net.ipv4.conf.default.accept_redirects"
	sflag1=`kernel_p_common $kernel_p1 0;echo $?`
	sflag2=`kernel_p_common $kernel_p2 0;echo $?`
	if [ $sflag1 -eq 2 -a $sflag2 -eq 2 ];then
		if [ `sysctl -n $kernel_p1|grep -w "0" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
			if [ `sysctl -n $kernel_p2|grep -w "0" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                		echo -e "--,不接受icmp重定向,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			else
				if [ `sysctl -p 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                			echo -e "--,不接受icmp重定向,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
					echo -e "COMMAND::0019::::sysctl -w $kernel_p1=1" >>/var/log/security_reinforce.txt
				else
                			echo -e "--,不接受icmp重定向,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				fi
			fi
		else
			if [ `sysctl -p 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                		echo -e "--,不接受icmp重定向,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo -e "COMMAND::0019::::sysctl -w $kernel_p1=1" >>/var/log/security_reinforce.txt
				echo -e "COMMAND::0019::::sysctl -w $kernel_p2=1" >>/var/log/security_reinforce.txt
			else
                		echo -e "--,不接受icmp重定向,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi
	
	elif [ $sflag1 -eq 0 -a $sflag2 -eq 0 ];then
		if [ `sysctl -p 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                	echo -e "--,不接受icmp重定向,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			echo -e "COMMAND::0019::::sysctl -w $kernel_p1=1" >>/var/log/security_reinforce.txt
			echo -e "COMMAND::0019::::sysctl -w $kernel_p2=1" >>/var/log/security_reinforce.txt
		else
                	echo -e "--,不接受icmp重定向,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		fi
	elif [ $sflag1 -eq 1 -o $sflag2 -eq 1 ];then
                echo -e "--,不接受icmp重定向,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $sflag1 -eq 2 -o $sflag2 -eq 2 ];then
		if [ `sysctl -p 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                	echo -e "--,不接受icmp重定向,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			echo -e "COMMAND::0019::::sysctl -w $kernel_p1=1" >>/var/log/security_reinforce.txt
			echo -e "COMMAND::0019::::sysctl -w $kernel_p2=1" >>/var/log/security_reinforce.txt
		else
                	echo -e "--,不接受icmp重定向,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		fi
	else
                echo -e "--,不接受icmp重定向,\033[31m [其他错误]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'

	fi
}

##########################################################################################
#tcp_syncookies加固
##########################################################################################
function Tcp_sysncookies(){

	echo "--tcp_syncookies加固"
        kernel_p1="net.ipv4.tcp_syncookies"
        sflag1=`kernel_p_common $kernel_p1 1;echo $?`
        if [ $sflag1 -eq 2 ];then
                if [ `sysctl -n $kernel_p1|grep -w "1" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                        echo -e "--,tcp_syncookies加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
                else
                        if [ `sysctl -p 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                                echo -e "--,tcp_syncookies加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo -e "COMMAND::0019::::sysctl -w $kernel_p1=0" >>/var/log/security_reinforce.txt
                        else
                                echo -e "--,tcp_syncookies加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
                        fi
                fi
        elif [ $sflag1 -eq 0 ];then
                if [ `sysctl -p 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
                        echo -e "--,tcp_syncookies加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			echo -e "COMMAND::0019::::sysctl -w $kernel_p1=0" >>/var/log/security_reinforce.txt
                else
                        echo -e "--,tcp_syncookies加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
                fi
        elif [ $sflag1 -eq 1 ];then
                echo -e "--,tcp_syncookies加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
        else
                echo -e "--,tcp_syncookies加固,\033[31m [其他错误]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'

        fi
}

##########################################################################################
#禁用ipv6
##########################################################################################
function Disable_ipv6() { 
	echo "--禁用ipv6" 
	declare -i flag1=1
    local kernel_p1="net.ipv6.conf.all.disable_ipv6"  
    local kernel_p2="net.ipv6.conf.default.disable_ipv6"  
    local kernel_p3="net.ipv6.conf.lo.disable_ipv6"  
  
    # 禁用所有相关的 IPv6 sysctl 参数  
    for param in "$kernel_p1" "$kernel_p2" "$kernel_p3"; do  
    	sflag=`kernel_p_common $param 1;echo $?`
        if [ $sflag -ne 2 ]; then 
        	flag1=0 
        fi  
    done  
  
    if [ $flag1 -eq 0 ];then 
	    if [ `sysctl -p 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then
	        echo -e "--,禁用ipv6,\033[32m [成功]\033[0m" | awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2, $3}' 
	    else  
	        echo -e "--,禁用ipv6,\033[31m [失败]\033[0m" | awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2, $3}'  
	    fi
	fi

    if [ $flag1 -eq 1 ];then
			echo -e "--,auth行为日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi
}


##########################################################################################
#记录uucp行为日志
##########################################################################################
function Uucp_log_configuration(){
	
	echo "--记录uucp行为日志"
	if [ `test -e /etc/rsyslog.d/50-default.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/rsyslog.d/50-default.conf|grep "uucp.\*"|awk '{print $2,$1}'|grep -v "^#"|grep "uucp.\*" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			echo -e "--,uucp日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		else
			if [ `echo "uucp.*       			-/var/log/uucp.log" >> /etc/rsyslog.d/50-default.conf 2>/dev/null;echo $?` -eq 0 ];then
				echo -e "--,uucp日志记录加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo "ADD_CONFIG::/etc/rsyslog.d/50-default.conf::uucp.*::uucp.*       			-/var/log/uucp.log" >>/var/log/security_reinforce.txt
			else
				echo -e "--,uucp日志记录加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi

		if [ ! -f /var/log/uucp.log ];then
			touch /var/log/uucp.log
			chmod 666 /var/log/uucp.log
		fi
	else
		echo -e "--,uucp日志记录加固,\033[31m [请安装日志工具]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}

##########################################################################################
#记录news行为日志
##########################################################################################
function News_log_configuration(){
	
	echo "--记录news行为日志"
	if [ `test -e /etc/rsyslog.d/50-default.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/rsyslog.d/50-default.conf|grep "news.\*"|awk '{print $2,$1}'|grep -v "^#"|grep "news.\*" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			echo -e "--,news日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		else
			if [ `echo "news.*          			-/var/log/news.log" >> /etc/rsyslog.d/50-default.conf 2>/dev/null;echo $?` -eq 0 ];then
				echo -e "--,news日志记录加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo "ADD_CONFIG::/etc/rsyslog.d/50-default.conf::news.*::news.*          			-/var/log/news.log" >>/var/log/security_reinforce.txt
			else
				echo -e "--,news日志记录加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi

		if [ ! -f /var/log/news.log ];then
			touch /var/log/news.log
			chmod 666 /var/log/news.log
		fi
	else
		echo -e "--,news日志记录加固,\033[31m [请安装日志工具]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}

##########################################################################################
#记录lpr行为日志
##########################################################################################
function Lpr_log_configuration(){
	
	echo "--记录lpr行为日志"
	if [ `test -e /etc/rsyslog.d/50-default.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/rsyslog.d/50-default.conf|grep "lpr.\*"|awk '{print $2,$1}'|grep -v "^#"|grep "lpr.\*" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			echo -e "--,lpr日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		else
			if [ `echo "lpr.*          			-/var/log/lpr.log" >> /etc/rsyslog.d/50-default.conf 2>/dev/null;echo $?` -eq 0 ];then
				echo -e "--,lpr日志记录加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo "ADD_CONFIG::/etc/rsyslog.d/50-default.conf::lpr.*::lpr.*          			-/var/log/lpr.log" >>/var/log/security_reinforce.txt
			else
				echo -e "--,lpr日志记录加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi

		if [ ! -f /var/log/lpr.log ];then
			touch /var/log/lpr.log
			chmod 666 /var/log/lpr.log
		fi
	else
		echo -e "--,lpr日志记录加固,\033[31m [请安装日志工具]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}


##########################################################################################
#记录syslog行为日志
##########################################################################################
function Syslog_log_configuration(){
	
	echo "--记录syslog行为日志"
	if [ `test -e /etc/rsyslog.d/50-default.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/rsyslog.d/50-default.conf|grep "syslog.\*"|awk '{print $2,$1}'|grep -v "^#"|grep "syslog.\*" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			echo -e "--,syslog日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		else
			if [ `echo "syslog.*          			-/var/log/syslog.log" >> /etc/rsyslog.d/50-default.conf 2>/dev/null;echo $?` -eq 0 ];then
				echo -e "--,syslog日志记录加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo "ADD_CONFIG::/etc/rsyslog.d/50-default.conf::syslog.*::syslog.*          			-/var/log/syslog.log" >>/var/log/security_reinforce.txt
			else
				echo -e "--,syslog日志记录加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi

		if [ ! -f /var/log/syslog.log ];then
			touch /var/log/syslog.log
			chmod 666 /var/log/syslog.log
		fi
	else
		echo -e "--,syslog日志记录加固,\033[31m [请安装日志工具]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}

##########################################################################################
#记录User行为日志
##########################################################################################
function User_log_configuration(){
	
	echo "--记录user行为日志"
	if [ `test -e /etc/rsyslog.d/50-default.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/rsyslog.d/50-default.conf|grep "user.\*"|awk '{print $2,$1}'|grep -v "^#"|grep "user.\*" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			echo -e "--,user日志记录加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		else
			if [ `echo "user.*          			-/var/log/user.log" >> /etc/rsyslog.d/50-default.conf 2>/dev/null;echo $?` -eq 0 ];then
				echo -e "--,user日志记录加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
				echo "ADD_CONFIG::/etc/rsyslog.d/50-default.conf::user.*::user.*          			-/var/log/user.log" >>/var/log/security_reinforce.txt
			else
				echo -e "--,user日志记录加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			fi
		fi

		if [ ! -f /var/log/user.log ];then
			touch /var/log/user.log
			chmod 666 /var/log/user.log
		fi
	else
		echo -e "--,user日志记录加固,\033[31m [请安装日志工具]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi

}

##########################################################################################
#logrotate日志轮询
##########################################################################################
function logrotate_reinforce(){

	rotate=$1 
    echo "--设置审计日志保留半年"

    if [ `cat -n /etc/logrotate.conf|grep "rotate"|awk '{print $2,$1}'|grep -v "^#"|grep "rotate" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then   
        line=`cat -n /etc/logrotate.conf|grep "rotate"|awk '{print $2, $1}'|grep -v "^#"|grep "rotate"|tail -n 1|awk '{print $2}'`
        value=`cat /etc/logrotate.conf|grep "rotate"|awk '{print $1,$2}'|grep -v "^#"|grep -w "rotate"|awk '{print $2}'`
        setline=$(($line - 1))
        if [[ $value  -ne $rotate ]];then
        
            if [ $setline -eq 0 ];then
                sed -i "1 d" /etc/logrotate.conf
                if [ `sed -i "1 a rotate $rotate" /etc/logrotate.conf 2>/dev/null;echo $?` -eq 0 ];then
                    echo "MODIFY_CONFIG1::/etc/logrotate.conf::rotate::rotate $value" >>/var/log/security_reinforce.txt
                    echo -e "--,审计日志保留半年加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
                else
                    echo -e "--,审计日志保留半年加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
                fi

            else
                sed -i "$line d" /etc/logrotate.conf
                if [ `sed -i "$setline a rotate $rotate" /etc/logrotate.conf 2>/dev/null;echo $?` -eq 0 ];then
                    echo "MODIFY_CONFIG1::/etc/logrotate.conf::rotate::rotate $value" >>/var/log/security_reinforce.txt
                    echo -e "--,审计日志保留半年加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
                else
                    echo -e "--,审计日志保留半年加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
                fi
            fi
        else
            echo -e "--,审计日志保留半年加固,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
        fi
    else
        if [ `echo "rotate $rotate" >> /etc/logrotate.conf 2>/dev/null;echo $?` -eq 0 ];then
            echo "ADD_CONFIG::/etc/logrotate.conf::rotate $rotate::rotate $rotate" >>/var/log/security_reinforce.txt
            echo -e "--,审计日志保留半年加固,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
        else
            echo -e "--,审计日志保留半年加固,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
        fi
    fi
}

Passwd_character_class 3
Passwd_minlen_setting 8
Password_usercheck_enable
Password_history
Password_faillock_setting


Cron_log_configuration
Daemon_log_configuration
Uucp_log_configuration
News_log_configuration
Lpr_log_configuration
Syslog_log_configuration
User_log_configuration

systemctl restart rsyslog.service

logrotate_reinforce 26

Ssh_banner_before_login
Ssh_banner_after_login

Icmp_accept_redirects_disable
Tcp_sysncookies
Disable_ipv6

Session_timeout  300
